Subject: bug#62677: 30.0.50; Need to find a better name for flyspell-prog-mode

From: Stefan Kangas <[email-masked]>
Date: Wed, 6 Sep 2023 11:51:14 -0700

retitle 62677 Merge flyspell-mode with flyspell-prog-mode
tags 62677 + easy
thanks

Eli Zaretskii <[email-masked]> writes:

>> I'm not sure why I can't just enable `flymake-mode' and have it do the
>> right thing, which IMO would be to enable `flymake-prog-mode' in modes
>> where it might make sense to have that behavior.  Major modes can tell
>> us what makes sense themselves, and if there are modes where the
>> decision is not clear-cut, they could make it into a user option.
>>
>> Enabling something like `flymake-global-mode' and have it just work
>> would be pretty neat.
>
> I guess you mean flyspell-mode.
>
> Yes, having the command automatically DTRT is always best.  So if we
> can do that in at least some significant proportion of cases, I think
> we should.

I took a look, and it seems like it would be a relatively
straightforward addition to `flyspell-mode'.  I'm adding the tag "easy",
as this seems like a pretty good introductory project.

Here's the plan I'd propose: Add a new defvar-local
`flyspell-use-prog-mode' or somesuch that major modes can set.  Now,
when a user enables `flymake-mode' in a buffer where that variable is
non-nil, the extra stuff done in `flyspell-prog-mode' gets done too.
Then decide which built-in major modes that would benefit, and set that
variable in them.

Would `prog-mode' be a candidate though, or do we expect any modes
inheriting from it to want the regular `flyspell-mode'?